Package org.codehaus.groovy.transform

# Class ParallelASTTransformation

java.lang.Object
org.codehaus.groovy.transform.ParallelASTTransformation

All Implemented Interfaces:
  `ASTTransformation`

@Incubating public class ParallelASTTransformation extends Object implements ASTTransformation
Local AST transform for `Parallel`: rewrites annotated `for-in` loops into `collection.eachParallel { item -> body }`.

The transform renames references to the loop variable in the body to a synthetic name (e.g. `$parallel_item`) to avoid scope conflicts with the for loop's own variable declaration, then re-resolves variable scopes to ensure the closure captures enclosing variables correctly.

Since:
  6.0.0

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ParallelASTTransformation()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ParallelASTTransformation

    public ParallelASTTransformation()

- ## Method Details

  - ### visit

    public void visit(ASTNode[] nodes, SourceUnit source)
    Description copied from interface: `ASTTransformation`
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Specified by:
      `visit` in interface `ASTTransformation`
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.